/**
 * https://leetcode.cn/problems/two-sum-ii-input-array-is-sorted/?envType=study-plan-v2&envId=top-interview-150
 * @param {number[]} numbers
 * @param {number} target
 * @return {number[]}
 */
const twoSum = function (numbers, target) {

};

/*
利用数组有序的特性，使用首位指针，不断的缩小范围找到可能的值
 */
function f1(numbers, target) {
  let left = 0;
  let right = numbers.length - 1;
  const temp = Infinity;
  while (left < right) {
    const temp = numbers[left] + numbers[right];
    if (temp == target) {
      return [left + 1, right + 1];
    } if (temp > target) {
      right--;
    } else { left++; }
  }
  return []; // 没有找到，不过这个题目测试用例保证一定有解
}
